//-----------------------------------------------------------------------------
/*
Programmed by Olivier Sangala
http://olivier.sangala.free.fr
olivier_sangala@hotmail.com
*/
//-----------------------------------------------------------------------------

// From 'TICT Game Construction Kit' by Thomas Nussbaumer

//--------------------------------------------------------------------------
// KBLIB FUNCTIONS
//--------------------------------------------------------------------------

#include <tigcclib.h>         // Include All Header Files
#include "kblib.h"

//-----------------------------------------------------------------------------

INT_HANDLER IntHandler1_OLD;
INT_HANDLER IntHandler5_OLD;

KBSTATE (*GetKeyboardStatePtr)(void);

KBSTATE kb_state;
KBSTATE kb_state_OLD;
KBSTATE kb_state_DOWN;
KBSTATE kb_state_UP;

void (*HandlerFuncPtr5)(void);

//-----------------------------------------------------------------------------

DEFINE_INT_HANDLER (IntHandler5)
{
	if (HandlerFuncPtr5)
	HandlerFuncPtr5();
	ExecuteHandler (IntHandler5_OLD);
}

//-----------------------------------------------------------------------------

void KB_Enable(void)
{
	
	kb_state = 0;
	kb_state_OLD = 0;
	kb_state_DOWN = 0;
	kb_state_UP = 0;
	
	GetKeyboardStatePtr = TI89?GetKeyboardState89:GetKeyboardState92P;
	
	IntHandler1_OLD = GetIntVec(AUTO_INT_1);
	IntHandler5_OLD = GetIntVec(AUTO_INT_5);
	SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
	SetIntVec(AUTO_INT_5,IntHandler5);
	
}

//-----------------------------------------------------------------------------

void KB_Disable(void)
{
	SetIntVec (AUTO_INT_1,IntHandler1_OLD);   
	SetIntVec (AUTO_INT_5,IntHandler5_OLD); 
}
//-----------------------------------------------------------------------------

KBSTATE GetKeyboardState(void)
{
	
	kb_state = GetKeyboardStatePtr();
	
	kb_state_DOWN = ((kb_state_OLD^kb_state) & ( kb_state));
	kb_state_UP   = ((kb_state_OLD^kb_state) & (~kb_state));
	kb_state_OLD  = kb_state;
	
	return kb_state;
	
}
//-----------------------------------------------------------------------------


KBSTATE GetKeyboardState89(void)
{
	register unsigned char val;
	register KBSTATE       key = 0;
	
	val = _rowread(~(1<<0));
	if (val & 0x01) key |= KEYFLAGS_UP;     // up
	if (val & 0x02) key |= KEYFLAGS_LEFT;   // down
	if (val & 0x04) key |= KEYFLAGS_DOWN;   // left
	if (val & 0x08) key |= KEYFLAGS_RIGHT;  // right
	if (val & 0x10) key |= KEYFLAGS_KA;     // 2nd
	if (val & 0x40) key |= KEYFLAGS_KB;     // Diamond
	if (val & 0x20) key |= KEYFLAGS_KE;     // Shift
	if (val & 0x80) key |= KEYFLAGS_KF;     // Alpha
	val = _rowread(~(1<<1));
	if (val & 0x02) key |= KEYFLAGS_PLUS;   // +
	if (val & 0x04) key |= KEYFLAGS_MINUS;  // -
	val =_rowread(~(1<<4));
	if (val & 0x40) key |= KEYFLAGS_KG;     // Mode
	if (val & 0x20) key |= KEYFLAGS_KH;     // Y
	val = _rowread(~(1<<5));
	if (val & 0x01) key |= KEYFLAGS_MODE;   // APPS
	if (val & 0x40) key |= KEYFLAGS_KC;     // Home
	if (val & 0x20) key |= KEYFLAGS_KD;     // X
	if (_rowread(~(1<<6)) & 0x01) key |= KEYFLAGS_ESC;    // ESC
	
	return key;
}
//-----------------------------------------------------------------------------

KBSTATE GetKeyboardState92P(void)
{
	register unsigned char val;
	register KBSTATE       key = 0;
	
	val = _rowread(~(1<<0));
	if (val & 0x10) key |= KEYFLAGS_LEFT;             //up
	if (val & 0x20) key |= KEYFLAGS_UP;               //down
	if (val & 0x40) key |= KEYFLAGS_RIGHT;            //left
	if (val & 0x80) key |= KEYFLAGS_DOWN;             //right
	if (_rowread(~(1<<1)) & 0x10) key |= KEYFLAGS_KH; //F8
	if (_rowread(~(1<<2)) & 0x10) key |= KEYFLAGS_KC; //F3
	if (_rowread(~(1<<3)) & 0x10) key |= KEYFLAGS_KG; //F7
	if (_rowread(~(1<<4)) & 0x10) key |= KEYFLAGS_KB; //F2
	if (_rowread(~(1<<5)) & 0x10) key |= KEYFLAGS_KF; //F6
	if (_rowread(~(1<<6)) & 0x10) key |= KEYFLAGS_KA; //F1
	val = _rowread(~(1<<7));
	if (val & 0x40) key |= KEYFLAGS_MODE;             //APPS
	if (val & 0x10) key |= KEYFLAGS_KE;               //F5
	val = _rowread(~(1<<8));
	if (val & 0x40) key |= KEYFLAGS_ESC;              //ESC
	if (val & 0x10) key |= KEYFLAGS_PLUS;             //+
	val = _rowread(~(1<<9));
	if (val & 0x01) key |= KEYFLAGS_MINUS;            //-
	if (val & 0x10) key |= KEYFLAGS_KD;               //F4
	
	return key;
}
//-----------------------------------------------------------------------------

void WaitForKeyDOWN(KBSTATE Key)
{
	while (!(kb_state_DOWN&Key))
	GetKeyboardState();
}
//-----------------------------------------------------------------------------

void WaitForKeyUP(KBSTATE Key)
{
	while (!(kb_state_UP&Key))
	GetKeyboardState();
}
//-----------------------------------------------------------------------------



